'//////////////////////////////////////////////////////////
'///    FastAVR Basic Compiler for AVR by MICRODESIGN   ///
'///    Display ADC numbers on an LCD                   ///
'///    Marvin Fugate                                   ///
'//////////////////////////////////////////////////////////
' simple program I wrote to test the ADC and LCD.
' I used ADC channel 1 for no particular reason 
' the "filter" is just a real basic average filter
' later I  intend to make some sort of floating average filter
' that would update each cycle(no for-next loop needed)
' I used a 10k pot on the AREF to test ADC accuracy at low 
' voltage levels. I was pleased with the quality of the 
' on-board ADC.
'
'
$Device= m163			' used device
$Stack = 32           	' stack size
$Clock = 8			    ' used clock in MHz
$Lcd   = PORTC.4, rs=PORTC.3, en=PORTC.2 , 20, 2	'lcd config 
$Source= On             ' displays comments in asm file

Dim n As Byte                   
Dim volts As Word
Dim voltraw As Word
Dim voltav As Word
Start Adc
Cursor Off

Do
   For n = 1 To 40         ' sample the adc 40 times for  
	   WaitUs 10               '    
	   voltraw = Adc(1)              
	   Locate 1,1: Lcd "Raw Input   "; voltraw; "   "
	   voltav = voltav + voltraw
   Next
	voltav = voltav / 40       ' average the ADC samples 
	Locate 2,1: Lcd "Filtered    "; voltav; "   "     
Loop

