'//////////////////////////////////////////////////////////
'///    FastAVR Basic Compiler for AVR by MICRODESIGN   ///
'///    ImageArray Toshiba T6963C DEMO                  ///
'///	ImgArrT6963.bas               www.FastAVR.com   ///
'//////////////////////////////////////////////////////////
$Device= 8515				' used device
$Stack = 32                	' stack size
$Clock = 7.3728
$GLCD T6963C, data=PORTA, ctrl=PORTC, 240, 128, 1
$Gctrl CD=0, CE=3, RD=1, WR=2, FS=1
$Source= On

Dim n As Byte
Dim Arrows6 As Flash Byte

Set DDRC.5				' LCD Reset is here
Reset PORTC.5			' so generate Reset

GrpHomeSet 0
GrpAreaSet 40           ' screen width (FS=1 -> 6x8)
Gcommand &h80  			' graphic screen ON
Gcommand &h98  			' graphic screen ON
Gcls					' clear gaphic screen

Do
	For n=0 To 3
		ImgSet(1,8,n),Arrows6
		WaitMs 250
		WaitMs 250
	Next
Loop

$Include "c:\FastAVR\Arrows6.bas"
