'////////////////////////////////////////////////////////////////////
'///  FastAVR Basic Compiler by MICRODESIGN,     www.FastAVR.com  ///
'///  Compare (Timer1)  1 channel SERVO                           ///
'///  Servo.bas                                                   ///
'////////////////////////////////////////////////////////////////////
$Device= 8515				' used device
$Stack = 20                	' stack size
$Clock = 7.3728				' used clock in MHz
$Timer1=Timer, Prescale=64
$Timer1=Compare, A=Toggle, Clear
$Source= On

Dim t As Byte
Dim ph As Bit

Declare Interrupt Oc1A()

Start Timer1
Enable Oc1
Enable Interrupts

Set DDRB.3 						' here is Compare1A output
Compare1A=&h0073				' 1ms @ 7.3728MHz

Do                        		' from 1ms to 2ms
	For t=115 To 230 Step 5		' 23 steps (43us)
		WaitMs 250
	Next
	For t=230 To 115 Step -5	' 23 steps (43us)
		WaitMs 100
	Next
Loop

'////////////////////////////////////////////////////////////////////
Interrupt Oc1A(), Save 1		' toggling PORTB.3 pin
If ph Then
	Compare1A=t
	ph=0
Else							' repetition time
	Compare1A=&h0900			' 20ms ((1+n)*2)/Clock
	ph=1
End If
End Interrupt
